greenhouses = {};

--needs module greenhouses
--lineType 2/greenhouses
function greenhouses:load(greenhouseName)
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};		
	if moGreenhouses.values.greenhouses ~= nil and moGreenhouses.values.greenhouses[greenhouseName] ~= nil then		
		for greenhouse=1, #moGreenhouses.values.greenhouses[greenhouseName] do		
			if moGreenhouses.values.greenhouses[greenhouseName][greenhouse] ~= nil then				
				local greenhouseGeneral = moGreenhouses.values.greenhouses[greenhouseName][greenhouse].general[1];
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];			
				
				if #moGreenhouses.values.greenhouses[greenhouseName] > 1 and greenhouse ~= 1 then					
					isLineTable.setLineBorderNewObject = true;	
				end;
				
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = bgas.returnLineHelpIconClick
				isLineTable.helpTxt = "Click GreenhouseName/%/FillLevel or .... ++ for more info (or MapHotSpot)";
				
				isLineTable.ownValues = {greenhouseName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].nodeId = greenhouseGeneral.object.nodeId;
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
				isLineTable.txt[1].bold = true;				
				local isNearObject = moModule:nearPlayerPosition(greenhouseGeneral.object, 20);				
				if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = greenhouses.returnClickObjectName;end;				
				if isNearObject ~= nil and isNearObject then
					isLineTable.txt[1].txt = ">>".. greenhouseGeneral.objectName.. "<<";
				else
					isLineTable.txt[1].txt = greenhouseGeneral.objectName;
				end;
				isLineTable.txt[1].txtPos = 1;				
				
				--productivity				
				lineTable[#lineTable+1] = {};
				isLineTable = lineTable[#lineTable];				
				isLineTable.ownValues = {greenhouseName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].width = 80;	--width prozent	
				local color = Utils.getNoNil(moColors.prozent[greenhouseGeneral.productivityColor], 1);
				isLineTable.txt[1].color = moColors:getColor(color, nil, moModule.values.txtColor);
				isLineTable.txt[1].bold = moModule.values.txtBold;
				isLineTable.txt[1].txt = greenhouseGeneral.productivityName;
				isLineTable.txt[2] = {};			
				isLineTable.txt[2].width = 20;	--width prozent	
				isLineTable.txt[2].color = moColors:getColor(color, nil, moModule.values.txtColor);
				isLineTable.txt[2].bold = moModule.values.txtBold;
				isLineTable.txt[2].txt = greenhouseGeneral.productivity.. "%";				
				isLineTable.txt[2].txtPos = 2;
				--productivity
				
				--output
				local greenhouseOutput = moGreenhouses.values.greenhouses[greenhouseName][greenhouse].output;
				if greenhouseOutput ~= nil and #greenhouseOutput > 0 then										
					local outputTable = moGreenhouses.values.greenhouses[greenhouseName][greenhouse].output[1];
					---
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];			
					isLineTable.ownValues = {greenhouseName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};
					isLineTable.txt[1].width = 70;	--width prozent	
					isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = moLanguageXml:getTxt("ages", nil, "Age");					
					isLineTable.txt[2] = {};
					isLineTable.txt[2].width = 30;	--width prozent	
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = tostring(outputTable.age).. " ".. moLanguageXml:getTxt("ageday", nil, "Day(s)");
					isLineTable.txt[2].txtPos = 2;
					---
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];			
					isLineTable.ownValues = {greenhouseName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};
					isLineTable.txt[1].width = 70;	--width prozent	
					isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = moLanguageXml:getTxt("incomeperhour", nil, g_i18n:getText("shop_income"));					
					isLineTable.txt[2] = {};
					isLineTable.txt[2].width = 30;	--width prozent	
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = g_i18n:formatMoney(outputTable.incomePerHour);
					isLineTable.txt[2].txtPos = 2;
				end;			
				--output
				
				--input
				local greenhouseInput = moGreenhouses.values.greenhouses[greenhouseName][greenhouse].input;
				if greenhouseInput ~= nil and #greenhouseInput > 0 then
					--isLineTable.lineBorder = {4, 0.0005, false, true, false, false, moColors:getColor(moGreenhouses.values.txtTitleColor)};					
					isLineTable.txt[1].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 0};
					isLineTable.txt[2].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 2};
					for input=1, #moGreenhouses.values.greenhouses[greenhouseName][greenhouse].input do
						local inputTable = moGreenhouses.values.greenhouses[greenhouseName][greenhouse].input[input];
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];					
						isLineTable.ownValues = {greenhouseName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[1].bold = moModule.values.txtBold;						
						isLineTable.txt[1].txt = inputTable.fillTypeName;						
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;
						isLineTable.txt[2].txt = inputTable.percentageCapacity.. "%";
						isLineTable.txt[2].clickCallback = greenhouses.returnClickFillLevelCapacityTotal;
						isLineTable.txt[2].ownValues = {tostring(inputTable.capacity), tostring(inputTable.fillLevel)};
						isLineTable.txt[2].txtPos = 2;
					end;
				end;
				--input							
			end;		
		end;		
	end;	
	greenhouses[greenhouseName] = {output=lineTable};	
end;

function greenhouses.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(greenhouses[args.ownValues[1]].output[args.line].helpTxt);
		end;
	end;
end;

function greenhouses.returnClickFillLevelCapacityTotal(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local capacity = greenhouses[args.ownValues[1]].output[args.line].txt[2].ownValues[1];
			local fillLevel = greenhouses[args.ownValues[1]].output[args.line].txt[2].ownValues[2];						
			moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
			local capacityLanguage = moLanguageXml:getTxt("capacity", nil, "Capacity:");
			local fillcontainerLanguage = moLanguageXml:getTxt("fillcontainer", nil, "Foodtrough:");						
			moSetGetOverlays.infoHelpBox.info.txt = tostring(capacityLanguage).. " ".. tostring(capacity).. "\n".. tostring(fillcontainerLanguage).. " ".. tostring(fillLevel);				
		
		end;
	end;
end;

function greenhouses.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local greenhouseName = args.ownValues[1];			
			if greenhouses[greenhouseName] ~= nil and greenhouses[greenhouseName].output ~= nil and greenhouses[greenhouseName].output[args.line] ~= nil then
				local nodeId = greenhouses[greenhouseName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;
		end;		
	end;
end;

function greenhouses.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.greenhouses.isRunning = true;moModule.active.greenhouses.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local greenhouseName = args.ownValues[1];		
			greenhouses:load(greenhouseName);
			return greenhouses[greenhouseName].output;
		end;
	end;
end;

function greenhouses.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--greenhouses:load();	
end;

function greenhouses:generateCmd(greenhouseName)
	local _, errorTable = 0, {};
	function insertCmd(greenhouseName, objectsNodes, objectsIds)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local greenhouseNameTemp = tostring(greenhouseName):lower();	
		local languageName = moLanguageXml:getTxt(greenhouseNameTemp, nil, greenhouseName);
		newCmdTable.cmdTable[1] = {
			cmdName = "greenhouses_".. tostring(greenhouseName);
			displayName = moLanguageXml:getTxt("greenhouses", nil, "Greenhouses").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "Greenhouses";
			infoTxt = "Zeigt alle Gewächshäuser an (".. tostring(languageName).. ")";
			helpTxt = "View all Greenhouses (".. tostring(greenhouseName).. ")";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = greenhouses.giveOutputTable; --a function
			ownValues = {greenhouseName, objectsNodes, objectsIds}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate greenhouses Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if greenhouseName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "greenhouses_".. greenhouseName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(greenhouseName);end;
	else
		if moGreenhouses.values.greenhouses ~= nil then
			for greenhouseName, _ in pairs (moGreenhouses.values.greenhouses) do
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "greenhouses_".. greenhouseName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(greenhouseName, moModule:getObjectIds(moGreenhouses.values.greenhouses[greenhouseName]));end;
			end;
		end;
	end;	
end;

